﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Xml;
using System.Xml.Linq;
using System.Xml.Serialization;

namespace Sales_Dashboard.Model
{
    public class ReportViewerClass
    {
        public void Loaded(object sender, RoutedEventArgs e)
        {
            Window mainWindow = sender as Window;
            Syncfusion.Windows.Reports.Designer.ReportDesigner ReportDesignerControl = mainWindow.FindName("ReportDesignerControl") as Syncfusion.Windows.Reports.Designer.ReportDesigner;
            //viewer.DataSources.Add(new ReportDataSource("Sales", new CompanySalesDemo.AdventureWorks().GetDataTable()));
            ReportDesignerControl.DesignMode = Syncfusion.Windows.Reports.Designer.DesignMode.RDLC;
            ReportDesignerControl.Assemblies = new List<Assembly>();
            //Enables the multiple RDL/RDLC files without rebuilding the application. 
            ReportDesignerControl.EnableMDIDesigner = true;
            //System.IO.FileInfo info = new System.IO.FileInfo("../../DataSource.dll");
            //Adds the assembly

            //ReportDesignerControl.Assemblies.Add(Assembly.LoadFile(info.FullName));
            ReportDesignerControl.Assemblies = new List<Assembly>();
            ReportDesignerControl.Assemblies.Add(Assembly.GetExecutingAssembly());
            //Sets the RDLC report path

            var filePath = new System.IO.FileInfo(@"../../ReportTemplate/BusinessData.rdlc").FullName;
            string path = System.IO.Path.GetFullPath(filePath);

            var reportDef = new Syncfusion.RDL.DOM.ReportDefinition();
            using (FileStream stream = new FileStream(filePath, FileMode.Open))
            {
                reportDef = LoadReport(stream);
            }

            var _assemblies = from t in Assembly.GetExecutingAssembly().GetTypes()
                              where t.Name == "AdventureWorks"
                              select t;
            var _methodInfo = _assemblies.First().GetMethod("GetData", (BindingFlags.NonPublic | BindingFlags.Public | BindingFlags.Instance | BindingFlags.Static));

            reportDef.DataSets[0].DataSetInfo = new Syncfusion.RDL.DOM.DataSetInfo();
            reportDef.DataSets[0].DataSetInfo.TableName = "AdventureWorks";
            reportDef.DataSets[0].DataSetInfo.DataSetName = reportDef.DataSets[0].Name;
            reportDef.DataSets[0].DataSetInfo.ObjectDataSourceSelectMethod = _methodInfo.Name;
            reportDef.DataSets[0].DataSetInfo.ObjectDataSourceSelectMethodSignature = _methodInfo.ToString();
            reportDef.DataSets[0].DataSetInfo.ObjectDataSourceType = _assemblies.First().AssemblyQualifiedName;

            this.SaveSerialize(new System.IO.FileInfo(@"../../ReportTemplate/BusinessDataCopy.rdlc").FullName, reportDef);

            ReportDesignerControl.OpenReport(new System.IO.FileInfo(@"../../ReportTemplate/BusinessDataCopy.rdlc").FullName);
        }

        Syncfusion.RDL.DOM.ReportDefinition LoadReport(Stream reportStream)
        {
            XElement rdl = XElement.Load(XmlReader.Create(reportStream));
            string Namespace = (from attribute in rdl.Attributes() where attribute.Name.LocalName == "xmlns" select attribute.Value).FirstOrDefault();
            string Version = (Regex.IsMatch(Namespace, @"\d{4}") ? Regex.Match(Namespace, @"\d{4}").Value : string.Empty);

            if (!string.IsNullOrEmpty(Version))
            {
                XmlSerializer xs = new XmlSerializer(typeof(Syncfusion.RDL.DOM.ReportDefinition), Namespace);//"http://schemas.microsoft.com/sqlserver/reporting/2008/01/reportdefinition"                
                using (StringReader reader = new StringReader(rdl.ToString()))
                {
                    Syncfusion.RDL.DOM.ReportDefinition o = (Syncfusion.RDL.DOM.ReportDefinition)xs.Deserialize(reader);
                    if (o != null)
                    {
                        switch (Version)
                        {
                            case "2008":
                                o.RDLType = Syncfusion.RDL.DOM.RDLType.RDL2008;
                                break;
                            case "2010":
                                o.RDLType = Syncfusion.RDL.DOM.RDLType.RDL2010;
                                break;
                            default:
                                o.RDLType = Syncfusion.RDL.DOM.RDLType.None;
                                break;
                        }
                        return o;
                    }
                }
            }

            return null;
        }

        private void SaveSerialize(string reportPath, Syncfusion.RDL.DOM.ReportDefinition report)
        {
            string nameSpace = "http://schemas.microsoft.com/sqlserver/reporting/2008/01/reportdefinition";

            if (report.RDLType == Syncfusion.RDL.DOM.RDLType.RDL2010)
            {
                nameSpace = "http://schemas.microsoft.com/sqlserver/reporting/2010/01/reportdefinition";
            }

            XmlSerializer xs2 = new XmlSerializer(typeof(Syncfusion.RDL.DOM.ReportDefinition), nameSpace);
            System.Xml.Serialization.XmlSerializerNamespaces xs = new XmlSerializerNamespaces();
            xs.Add("rd", "http://schemas.microsoft.com/SQLServer/reporting/reportdesigner");
            try
            {
                TextWriter ws2 = new StreamWriter(reportPath);
                xs2.Serialize(ws2, report, xs);
                ws2.Close();
            }
            catch
            {
            }
        }


    }
}
